/** @jsx jsx */
/// <reference types="react" />
import PropTypes from 'prop-types';
export declare const usePanelContext: () => never;
export declare const Panel: {
    ({ look, heading, headingTag, children, overrides: componentOverrides, ...rest }: any): JSX.Element;
    propTypes: {
        /**
         * Panel look
         */
        look: PropTypes.Validator<string>;
        /**
         * Panel heading text
         */
        heading: PropTypes.Validator<string>;
        /**
         * Panel heading tag
         */
        headingTag: PropTypes.Validator<string | ((...args: any[]) => any)>;
        /**
         * The override API
         */
        overrides: PropTypes.Requireable<PropTypes.InferProps<{
            Panel: PropTypes.Requireable<PropTypes.InferProps<{
                styles: PropTypes.Requireable<(...args: any[]) => any>;
                component: PropTypes.Requireable<PropTypes.ReactComponentLike>;
                attributes: PropTypes.Requireable<(...args: any[]) => any>;
            }>>;
            Header: PropTypes.Requireable<PropTypes.InferProps<{
                styles: PropTypes.Requireable<(...args: any[]) => any>;
                component: PropTypes.Requireable<PropTypes.ReactComponentLike>;
                attributes: PropTypes.Requireable<(...args: any[]) => any>;
            }>>;
            Heading: PropTypes.Requireable<PropTypes.InferProps<{
                styles: PropTypes.Requireable<(...args: any[]) => any>;
                component: PropTypes.Requireable<PropTypes.ReactComponentLike>;
                attributes: PropTypes.Requireable<(...args: any[]) => any>;
            }>>;
        }>>;
    };
    defaultProps: {
        look: string;
        headingTag: string;
    };
};
export declare const defaultProps: {
    look: string;
    headingTag: string;
};
